;*************************************************************** 
;* 
;* Jrmfedlzeti rendszerek I., 2. asm gyakorlat
;* 
;* Magas szint programnyelvek elgazsai Assembly-ben
;* 
;*************************************************************** 
;* 
;*  Kszitette: Aradi Szilrd
;*  Csoport:
;*  Dtum: 2012.01.25.
;* 
;*************************************************************** 

.include "m128def.inc"  ; ATmega128 defincis fjl
 
;*************************************************************** 
;* Konstansok 
;*************************************************************** 
 .equ  limit1 = 10
 .equ  limit2 = 0
 .equ  max = 10

;*************************************************************** 
;* Vltozk
;*************************************************************** 
.def  expr = r0

.def  a_cnt = r5 
.def  b_cnt = r6 
.def  c_cnt = r7
.def  d_cnt = r8

.def mpr  =r16 ;  Multipurpose  Register
.def  n = r17
.def  val = r18
.def  sum = r19
 
;*************************************************************** 
;* Megszakts vektorok
;*************************************************************** 
.cseg //Kdszegmens (FLASH) 
.org 0x0000     ; Kdszegmens kezdcme.

		jmp		init		; Reset vektor //Els megszakts vektor Reset utn ide ugrik
		jmp		dummy		; EXTINT0 Handler
		jmp		dummy		; EXTINT1 Handler
		jmp		dummy		; EXTINT2 Handler
		jmp		dummy		; EXTINT3 Handler
		jmp		dummy		; EXTINT4 Handler (INT gomb)
		jmp		dummy		; EXTINT5 Handler
		jmp		dummy		; EXTINT6 Handler
		jmp		dummy		; EXTINT7 Handler
		jmp		dummy		; Timer2 Compare Match Handler 
		jmp		dummy		; Timer2 Overflow Handler 
		jmp		dummy		; Timer1 Capture Event Handler 
		jmp		dummy		; Timer1 Compare Match A Handler 
		jmp		dummy		; Timer1 Compare Match B Handler 
		jmp		dummy		; Timer1 Overflow Handler 
		jmp		dummy		; Timer0 Compare Match Handler 
		jmp		dummy		; Timer0 Overflow Handler 
		jmp		dummy		; SPI Transfer Complete Handler 
		jmp		dummy		; USART0 RX Complete Handler 
		jmp		dummy		; USART0 Data Register Empty Hanlder 
		jmp		dummy		; USART0 TX Complete Handler 
		jmp		dummy		; ADC Conversion Complete Handler 
		jmp		dummy		; EEPROM Ready Hanlder 
		jmp		dummy		; Analog Comparator Handler 
		jmp		dummy		; Timer1 Compare Match C Handler 
		jmp		dummy		; Timer3 Capture Event Handler 
		jmp		dummy		; Timer3 Compare Match A Handler 
		jmp		dummy		; Timer3 Compare Match B Handler 
		jmp		dummy		; Timer3 Compare Match C Handler 
		jmp		dummy		; Timer3 Overflow Handler 
		jmp		dummy		; USART1 RX Complete Handler 
		jmp		dummy		; USART1 Data Register Empty Hanlder 
		jmp		dummy		; USART1 TX Complete Handler 
		jmp		dummy		; Two-wire Serial Interface Handler 
		jmp		dummy		; Store Program Memory Ready Handler 	

;*****************************************************************************
;* Inicializls
;*****************************************************************************


;***** Stack inicializlsa *****

//A kvetkez sorok a Stack Pointer regiszterbe tltik az SRAM vgt
init:	ldi		mpr,LOW(RAMEND)	; RAMEND = RAM vgcme
		out		SPL,mpr			; (ld."m128def.inc") 
		ldi		mpr,HIGH(RAMEND)
		out		SPH,mpr

;***** Port C inicializlsa *****
		ldi		mpr,0xFF
		out		DDRC, mpr
		ldi		mpr, 0x00
		out		PORTC, mpr

;*****************************************************************************
;* Fprogram
;*****************************************************************************		
	//ldi n,3
main:
; Program
		jmp		IF1

;***************************************************************
;* IF kifejezs
;* if (n >= 3)
;* { 
;*  expr++; 
;*   n = expr; 
;* }
;***************************************************************

;***** 1. verzi *****

IF1:	cpi		n,3		; sszehasonlt //Carry flag-et bebillenti
		brsh	EXEC1	; Ha n >= 3 igaz, akkor elgazs a EXEC-re	//Az operations sornl ltszik, hogy a Carry flag-et vizsglja akkor hajtdik vgre, ha c=0
		rjmp	NEXT1	; Ugrs a NEXT1-re ha a kifejezs hamis 
EXEC1:	inc		expr	; Megnvelem az expr-et
  		mov		n,expr	; n = expr //Regiszterek kztt lehet msolgatni
		out		PORTC,n	; Kijelzem n rtkt 
NEXT1:					; Folytats a tbbi programrsszel

;***** 2. verzi *****
IF2:	cpi		n,3		; sszehasonlt 
		brlo	NEXT2	; Ha n >= 3 hamis, akkor elgazs a NEXT2-re 
		inc		expr	; Megnvelem az expr-et
  		mov		n,expr	; n = expr
		out		PORTC,n	; Kijelzem n rtkt  
NEXT2:					; Folytats a tbbi programrsszel

;***************************************************************
;* IF-ELSE kifejezs
;* if (n == 5)
;*   expr++; 
;* else 
;*   n = expr; 
;***************************************************************

;***** 1. verzi *****
IF3S:	cpi		n,5		; sszehasonlt 
		breq	IF3		; Ha n == 5, akkor elgazs az IF3-ra
		rjmp  	ELSE1	; Ugrs az ELSE1-re ha a kifejezs hamis
IF3:	inc		expr	; Megnvelem az expr-et
  		rjmp	NEXT3	; Ugrs a NEXT3-ra 
ELSE1:	mov		n,expr	; n = expr
		out		PORTC,n	; Kijelzem n rtkt 
NEXT3:					; Folytats a tbbi programrsszel

;***** 2. verzi *****
IF4:	cpi		n,5		; sszehasonlt 
		brne	ELSE2	; Ha n == 5 hamis, akkor elgazs az ELSE2-re
		inc		expr	; Megnvelem az expr-et
  		rjmp	NEXT4	; Ugrs a NEXT4-re 
ELSE2:	mov		n,expr	; n = expr 
		out		PORTC,n	; Kijelzem n rtkt
NEXT4:					; Folytats a tbbi programrsszel

;***************************************************************
;* IF-ELSIF-ELSE kifejezs
;* if (n<3)
;*   expr++;
;* else if (n == 5)
;*   n = expr; 
;* else 
;*   n++; 
;***************************************************************

;***** 1. verzi *****
IF5S:	cpi		n,3		; sszehasonlt
		brlo	IF5		; Ha n < 3, akkor elgazs az IF5-re
		rjmp	ELIF1	; Ugrs az ELIF1-re
IF5:	inc		expr	; Megnvelem az expr-et
		rjmp	NEXT5	; Ugrs a NEXT5-re
ELIF1:	cpi		n,5		; sszehasonlts
		breq	ELIE1	; Ha n== 5, akkor elgazs ELIE1-re
		rjmp	ELSE3	; Ugrs a ELSE3-ra
ELIE1:	mov		n,expr	; n = expr
		out		PORTC,n	; Kijelzem n rtkt
		rjmp	NEXT5	; Ugrs a NEXT5-re
ELSE3:	inc		n		; n++
		out		PORTC,n	; Kijelzem n rtkt
NEXT5:					; Folytats a tbbi programrsszel

;***** 2. verzi *****
IF6:	cpi		n,3		; sszehasonlt
		brsh	ELIF2	; Ha n < 3 hamis, akkor elgazs az ELIF2-re
		rjmp	NEXT6	; Ugrs a NEXT6-ra
ELIF2:	cpi		n,5		; sszehasonlts
		brne	ELSE4	; Ha n== 5 hamis, akkor elgazs ELSE4-re
		mov		n,expr	; n = expr
		out		PORTC,n	; Kijelzem n rtkt
		rjmp	NEXT6	; Ugrs a NEXT6-ra
ELSE4:	inc		n		; n++
		out		PORTC,n	; Kijelzem n rtkt
NEXT6:					; Folytats a tbbi programrsszel

;***************************************************************
;* SWITCH-CASE kifejezs
;* switch (val) { 
;* case 1: 
;*  a_cnt++; 
;*  break; 
;* case 2:
;*  b_cnt++;
;*  break;
;* case 3: 
;*  c_cnt++; 
;*  break; 
;* default: 
;*  d_cnt++; 
;* } 
;***************************************************************

;***** 1. verzi *****
SWITCH1:
		cpi  	val, 1		; sszehasonltja val-t 1-gyel
  		breq  	S_1_1    	; Ha val == 1, akkor elgazs S_1_1-re
  		cpi  	val, 2		; sszehasonltja val-t 2-vel
		breq	S_1_2		; Ha val == 2, akkor elgazs S_1_2-re
		cpi		val, 3		; sszehasonltja val-t 3-mal
		breq	S_1_3		; Ha val == 3, akkor elgazs S_1_3-re
		inc		d_cnt		; Ha egyik sem, akkor default g
		out		PORTC,d_cnt	; Kijelzem d_cnt rtkt
		rjmp	NEXT7		; Kiugrs a SWITCH-bl
S_1_1:	inc		a_cnt		; 1-es g futtatsa
		out		PORTC,a_cnt	; Kijelzem a_cnt rtkt
		rjmp	NEXT7		; Kiugrs a SWITCH-bl
S_1_2:	inc		b_cnt		; 2-es g futtatsa
		out		PORTC,b_cnt	; Kijelzem b_cnt rtkt
		rjmp	NEXT7		; Kiugrs a SWITCH-bl
S_1_3:	inc		c_cnt		; 3-es g futtatsa
		out		PORTC,c_cnt	; Kijelzem c_cnt rtkt
NEXT7:						; Folytats a tbbi programrsszel

;***** 2. verzi *****
SWITCH2:
S_2_1:	cpi  	val, 1		; sszehasonltja val-t 1-gyel
		brne	S_2_2		; Ha val != 1, akkor elgazs S_2_2-re
		inc		a_cnt		; 1-es g futtatsa
		rjmp	NEXT8		; Kiugrs a SWITCH-bl
S_2_2:	cpi  	val, 2		; sszehasonltja val-t 2-vel
		brne	S_2_2		; Ha val != 2, akkor elgazs S_2_3-ra
		inc		b_cnt		; 2-es g futtatsa
		rjmp	NEXT8		; Kiugrs a SWITCH-bl
S_2_3:	cpi  	val, 3		; sszehasonltja val-t 3-mal
		brne	DFLT		; Ha val != 3, akkor elgazs DFLTR-ra
		inc		c_cnt		; 3-as g futtatsa
		rjmp	NEXT8		; Kiugrs a SWITCH-bl
DFLT:	inc		d_cnt		; Ha egyik sem, akkor default g
NEXT8:						; Folytats a tbbi programrsszel

;***************************************************************
;* WHILE-DO ciklus
;* while (n < 10) { 
;*  sum += n; 
;* n++; 
;* }
;***************************************************************

;***** 1. verzi *****
WHIL1:	cpi		n, limit1	; Ciklusvltoz vizsglata 
		brlo	WHEX1		; Ha n < limit, akkor ugrs WHEX1-re
		rjmp	NEXT9		; Egybknt kilps a ciklusbl 
WHEX1:	add		sum, n		; sum += n 
		inc		n			; n++
		out		PORTC, sum	; Kijelzem sum rtkt
		rjmp	WHIL1		; Vissza a ciklus elejre
NEXT9:						; Folytats a tbbi programrsszel

;***** 2. verzi *****
WHIL2:	cpi		n, limit1	; Ciklusvltoz vizsglata 
		brsh	NEXT10		; Ha n < limit felttel hamis, akkor kilps a ciklusbl
		add		sum, n		; sum += n 
		inc		n			; n++
		out		PORTC, sum	; Kijelzem sum rtkt
		rjmp	WHIL2		; Vissza a ciklus elejre
NEXT10:						; Folytats a tbbi proramrsszel

jmp		main

;***************************************************************
;* DO-WHILE (REPEAT-UNTIL) ciklus
;* do { 
;*  sum += n; 
;*   n--; 
;* } while (n > 0);
;***************************************************************

;***** 1. verzi *****
DO1:	add		sum, n		; sum += n 
		dec		n			; n--
		out		PORTC, sum	; Kijelzem sum rtkt
		cpi		n, limit2	; Ciklusvltoz vizsglata
		brne	DO1			; Ha nem 0, akkor vissza a ciklus elejre
NEXT11:						; Folytats a tbbi programrsszel

;***** 2. verzi *****
DO2:	add		sum, n		; sum += n 
		dec		n			; n--
		out		PORTC, sum	; Kijelzem sum rtkt
		brne	DO2			; Ha nem 0, akkor vissza a ciklus elejre
NEXT12:						; Folytats a tbbi programrsszel

;***************************************************************
;* FOR ciklus
;* for (n = 0; n < 10; n++) 
;*   sum += n; 
;***************************************************************

;***** 1. verzi *****
		ldi		n, 0		; Ciklusvltoz inicializlsa 0-ra
FOR1:	cpi		n,max		; Ciklusvltoz vizsglata
		brlo	EXEC2		; Ha n < max, akkor elgazs az EXEC2-re
		rjmp	NEXT13		; Ha vge a ciklusnak, akkor ugrs a NEXT13-ra
EXEC2:	add		sum, n		; sum += n
		out		PORTC, sum	; Kijelzem sum rtkt
		inc		n			; Ciklusvltoz nvelse
		rjmp	FOR1		; Ugrs a ciklus elejre
NEXT13:						; Folytats a tbbi programrsszel

;***** 2. verzi *****
		ldi		n, 0		; Ciklusvltoz inicializlsa max-ra
FOR2:	add		sum, n		; sum += n
		out		PORTC, sum	; Kijelzem sum rtkt
		dec		n			; Ciklusvltoz cskkentse
		brne	FOR2		; Ha n nem 0, akkor ugrs a ciklus elejre
NEXT14:						; Folytats a tbbi programrsszel

		jmp 	main;		; Vissza az elejre		

;*****************************************************************************
;* Szubrutinok
;*****************************************************************************

;*****************************************************************************
;* Megszakts kezel rutinok
;*****************************************************************************
	dummy:	reti;
;*****************************************************************************
;* Adatok
;*****************************************************************************
